/*!
 * 
 *   melonJS
 *   http://www.melonjs.org
 *		
 *   Step by step game creation tutorial
 *
 **/

// game resources
var g_resources= [{
	name: "tiles",
	type: "image",
	src: "data/tiles.png"
    }, {
	name: "test1",
	type: "tmx",
	src: "data/test1.tmx"
    }, {
	name: "moongirl",
	type: "image",
	src: "data/moongirl.png"
    }, {
	name: "earth",
	type: "image",
	src: "data/earth1.jpg"
    }, {
	name: "jump",
	type: "audio",
	src: "data/",
	channel: 1 // ??????
    }];


var jsApp	= 
{	
	/* ---
	
		Initialize the jsApp
		
		---			*/
	onload: function()
	{
		
		// init the video
		if (!me.video.init('jsapp', 640, 480, false, 1.0))
		{
			alert("Sorry but your browser does not support html 5 canvas.");
         return;
		}
				
		// initialize the "audio"
		//look for ogg, then wav. chrome seems to die if file is missing
		me.audio.init("ogg,wav");
		
		// set all resources to be loaded
		me.loader.onload = this.loaded.bind(this);
		
		// set all resources to be loaded
		me.loader.preload(g_resources);

		// load everything & display a loading screen
		me.state.change(me.state.LOADING);
	},
	
	
	/* ---
	
		callback when everything is loaded
		
		---										*/
	loaded: function ()
	{
	    // set the "Play/Ingame" Screen Object
	    me.state.set(me.state.PLAY, new PlayScreen());

	    // add player to entity pool (?)
	    me.entityPool.add("moongirl", PlayerEntity);

	    // keys
	    me.input.bindKey(me.input.KEY.LEFT, "left");
	    me.input.bindKey(me.input.KEY.RIGHT, "right");
	    // wonder if we can bind more than one key to jump...
	    me.input.bindKey(me.input.KEY.X, "jump", true);
	    
	    // start the game 
	    me.state.change(me.state.PLAY);
	}

}; // jsApp

/* the in game stuff*/
var PlayScreen = me.ScreenObject.extend(
{
    onResetEvent: function()
    {	
	// stuff to reset on state change
	
	// load level
	me.levelDirector.loadLevel("test1");
    },
    
    // action to perform when game is finished (state change)
    onDestroyEvent: function()
    {
	
    }
});


//bootstrap :)
window.onReady(function() 
{
	jsApp.onload();
});
